/************************************************************************/
/*  A Part of ARM Cortex-A9 GNU GDB Stub Software.			*/
/*   				Copyright (C) 2013 Toshio MURAI		*/
/* This program is free software; you can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 3 of the License, or	*/
/* (at your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details.  			*/
/************************************************************************/

extern	int	registers[];
#define	REGPC	15
#define	REGSP	13

#define UNDEF_ARM_INSTRUCTION 0xe7ffdefe

unsigned int	*savedAddress0 = 0;
unsigned int	*savedAddress1 = 0;
unsigned int	*savedAddress2 = 0;

unsigned int	savedInstruction0 = 0;
unsigned int	savedInstruction1 = 0;
unsigned int	savedInstruction2 = 0;

clearStepBreakPoints()
{
	if(savedAddress1) {
		savedAddress2 = savedAddress1;		// Debug Purpose
		savedInstruction2 =savedInstruction1;	// Debug Purpose
		*savedAddress1 = savedInstruction1;
		savedAddress1 =0;
		savedInstruction1 =0;
	}
	if(savedAddress0) {
		*savedAddress0 = savedInstruction0;
		savedAddress0 =0;
		savedInstruction0 =0;
	}
}

setStepBreakPoints()
{
	unsigned int *address;

//(1).	Set Next PC Address Break Point
	savedAddress0= (unsigned int*) registers[15];	//PC
	savedAddress0++;
	savedInstruction0 =  *savedAddress0;
	*savedAddress0 = 0xe7ffdefe;

//(2).	Set Branch Destination PC Address Break Point  //following address can be address0
	address = (unsigned int*) registers[15];	//PC

	// B	0x-Aaa aaaa
	// BL	0x-Baa aaaa
	if( (*address & 0x0e000000) == 0x0a000000) { 
		int	offset;
		offset = *address & 0x00ffffff;
		if(offset & 0x00800000){  // ugliy Should be changed ,but still OK.
			offset = 0x01000000 - offset ;	
			savedAddress1 = address - offset + 2;
		} else {
			savedAddress1 = address + offset + 2;
		}
	}	/* OK verified */

	// BX LR	0xe12f ff1e 	bx	lr
	if( (*address & 0x0ff000f0) == 0x01200010) { 
		savedAddress1 = (unsigned int *)registers[(*address) & 0x0f];
	}	/* OK verified	*/

	// BLX R3	0xe12f ff33 	blx	r3
	if( (*address & 0x0ff000f0) == 0x01200030) { 
		savedAddress1 = (unsigned int *)registers[(*address) & 0x0f];
	}	/* OK verified	*/

	// LDR	PC,xxxx		Should Support This Code Partiall
//	if ( (*address & 0x0ffffff0) == 0x01a0f000) { //e1a0f00e  mov pc, lr  e:always
	if ( (*address & 0xfffffff0) == 0xe1a0f000) { //e1a0f00e  mov pc, lr
		savedAddress1 = (unsigned int *)registers[(*address) &0x0f];
	}	/* OK verified	*/

	// LDR	PC,	0xe59ff018        LDR     PC, [PC, #24] 
	if ( (*address & 0x0ffff000) == 0x059ff000) { 
			savedAddress1 = (int*)* (address + 2 +  ( (*address & 0xfff) /4)    )  ;
	}	//  OK!   verified

	// LDRL PC, [PC, R1, LSL #2]	0x979ff101 Seems to nees to support this 
	// LDRL PC, [PC, R1, LSL #2]	0x-79----- Seems to nees to support this 
	//                                   RRSLR
	//                                   11hSm
	//                                   55iL
	//                                     f   shift = 2
	//                                     t   C Language switch use this code?
	if ( (*address & 0x0ffffff0) == 0x079ff100) { 
			savedAddress1 = (int*)* (address + 2 + registers[(*address) &0x0f])  ;
	}	// OK verified


	//LDM	SP!,{PC}	Should Support This Code Partially
	//	e8bd4800 	pop	{fp, lr}
	//	e8bd8800 	pop	{fp, pc}
	//savedAddress1 = ((unsigned int *)registers[SP])[1];
	//	e8bd981f 	pop	{r0, r1, r2, r3, r4, fp, ip, pc}
	//	e8fd981f 	ldm	sp!, {r0, r1, r2, r3, r4, fp, ip, pc}^
	//savedAddress1 = ((unsigned int *)registers[SP])[7];
	if ( (*address & 0xffbf8000) == 0xe8bd8000) { // e:always
		int field; //= *address & 0xffff; /*	0x7fff	*/
		int index = 0;
		for( field = *address & 0x7fff; field >0 ; field /= 2) {
			index += (field & 0x01) ;
		}
		savedAddress1 = (int*)(((unsigned int *)registers[13])[index]);//R13=SP
	}	// OK verified

	//	ADD/SUB PC,xxxx  will not Support this Kind of Brahch	*/

	if(savedAddress1) {
		savedInstruction1 =  *savedAddress1;
		*savedAddress1 = 0xe7ffdefe;
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////

int	vectorAddress=0x20100000;	// Taget Program vector Address Location

#define	RMPR		((volatile unsigned int *)0xFCFE1A00) //	Remap register

// Interrupt Set up 1st
#define	ICDISR	((volatile unsigned int*)0xE8201080)	// (1) Security
#define	ICDICFR	((volatile unsigned int*)0xE8201C00)	// (2) Configuration
#define	ICDIPR	((volatile unsigned int*)0xE8201400)	// (3) Priority
#define	ICDIPTR	((volatile unsigned int*)0xE8201800)	// (4) Target CPU
#define ICDISER	((volatile unsigned int*)0xE8201100)	// (5) Interrupt Enable
#define	ICDICER ((volatile unsigned int*)0xE8201180)	//	//Interrupt Enable Clear Register
#define	ICDISPR	((volatile unsigned int*)0xE8201200)	//	//Suspend set 
#define	ICDICPR	((volatile unsigned int*)0xE8201280)	//	//Suspend Clear  
#define	ICDABR	((volatile unsigned int*)0xE8201300)	//	//ACtive bit register 

// Interrupt Set up 2nd
struct cpuif_str {
	unsigned int	ICR;	//2nd.(3)	=0x00000003 CPU interface Control
	unsigned int	PMR;	//2nd.(1)	CPU  Priority Mask < 0xFF
	unsigned int	BPR;	//2nd.(2)	binary point ?= 0x00
	unsigned int	IAR;	//ICCIAR	((volatile unsigned int*)0xE820200C)
	unsigned int	EOIR;	//ICCEOIR	((volatile unsigned int*)0xE8202010)
	unsigned int	RPR;
	unsigned int	HPIR;	//ICCHPIR ((volatile unsigned int*)0xE8202018)
	unsigned int	ABPR;
	unsigned int	IIDR;
};
#define ICC	((volatile struct cpuif_str*) 0xE8202000)	// Distribute Control =1

// Interrupt Set up 3rd
#define	ICDDCR	 ((volatile unsigned int*)0xE8201000)	// Distribute Control =1
// Interrupt Set up 4th CPSR (I/F)

// IO structure
struct sc_str{
	unsigned short	SCSMR;	short NSCSMR;
	unsigned char	SCBRR;	char ZSCBRR;short NSCBRR;
	unsigned short	SCSCR;	short NSCSCR;
	unsigned char	SCFTDR;	char ZSCFTDR;short NSCFTDR;
	unsigned short	SCFSR;	short NSCFSR;
	unsigned char	SCFRDR;	char ZSCFRDR;short NSCFRDR;
	unsigned short	SCFCR;	short NSCFCR;
	unsigned short	SCFDR;	short NSCFDR;
	unsigned short	SCSPTR;	short NSCSPTR;
	unsigned short	SCLSR;	short NSCLSR;
	unsigned short	SCEMR;	short NSCEMR;
};
#define	SC3	((volatile struct sc_str *)0xE8008800)

struct gpio_str{
	unsigned short	P0;	short NP0;
	unsigned short	P1;	short NP1;
	unsigned short	P2;	short NP2;
	unsigned short	P3;	short NP3;
	unsigned short	P4;	short NP4;
	unsigned short	P5;	short NP5;
	unsigned short	P6;	short NP6;
	unsigned short	P7;	short NP7;
};

struct gpiol_str{
	unsigned int	P0;
	unsigned int	P1;
	unsigned int	P2;
	unsigned int	P3;
	unsigned int	P4;
	unsigned int	P5;
	unsigned int	P6;
	unsigned int	P7;
};

#define	PORT	((volatile struct gpio_str *)0xFCFE3000)
#define	PSR	((volatile struct gpiol_str *)0xFCFE3100)
#define	PPR	((volatile struct gpio_str *)0xFCFE3200)
#define	PM	((volatile struct gpio_str *)0xFCFE3300)
#define	PMC	((volatile struct gpio_str *)0xFCFE3400)
#define	PFC	((volatile struct gpio_str *)0xFCFE3500)
#define	PFCE	((volatile struct gpio_str *)0xFCFE3600)
#define	PNOT	((volatile struct gpio_str *)0xFCFE3700)
#define	PMSR	((volatile struct gpiol_str *)0xFCFE3800)
#define	PMCSR	((volatile struct gpiol_str *)0xFCFE3900)
#define	PFCAE	((volatile struct gpio_str *)0xFCFE3A00)
#define	PIBC	((volatile struct gpio_str *)0xFCFE4000)
#define	PBDC	((volatile struct gpio_str *)0xFCFE4100)
#define	PIPC	((volatile struct gpio_str *)0xFCFE4200)

/////////////////////////////////////////////////////////////////////////

initializeUART() {

	PMC->P7	|=	0x0C00	;
	PFCAE->P7	|=	0x0C00	;
	PFCE->P7	&= ~0x0C00	;
	PFC->P7	&= ~0x0C00	;	// 5th Fucntion mode ( TxD3/RxD3 )
	PM->P7		&= ~0x0800	;	// P7_11 TxD (0:out)
	PM->P7		|=  0x0400	;	// P7_10 RxD (1:in)

	SC3->SCSCR = 00;		// Control Register clear
	SC3->SCFCR = 06;		//  Reset FIFO 
	SC3->SCFCR = 00;		//

	SC3->SCBRR = 0x11;		//  0x11 115200  0x68 19200

	SC3->SCSMR = ((SC3->SCSMR & ~0xF8) | 0x00);		// Mode Register
	//	~0x80 Async	~0x40 8bit	~0x20 NoPa	~0x10 Even
	//	~0x08 1Stop	~0x04 Researve 	 0x03 1/64 0x02 1/16 0x01 1/4
	SC3->SCSCR = ((SC3->SCSCR & ~0x00) | 0xF8);		// Control Register
	//	 0x80 TIE	 0x40 RIE	 0x20 TE	 0x10 RE
	//	 0x08 REIE	~0x04 Researve	 0x00 Internal Clock 
	//i = SC3->SCFSR;	//
	SC3->SCFSR &= 0x00;	//
	//	 0xF000	Parity Error Numbrt	 0x0F00	Framing Error Numbrt
	//	 0x80 ERror	 0x40 TEND	 0x20 TDFEmpty	 0x10 BRK
	//	 0x0f FERror	 0x04 PERror	 0x02 RDFull	 0x01 (Recieve)DReasy

	//tfp_printf("***SCSCR%x:SCFSR%x\n",SC3->SCSCR,SC3->SCFSR);

// 1st for FIFO Serial IO3
//BRI3 ID;233 7.9 14.19-18 58.15-8
//ERI3 ID;234 7.10 14.21-20 58.23-16
//RXI3 ID;235 7.11 14.23-22 58.31-24
//TXI3 ID;236 7.12 14.25-24 59 7-0
	ICDISR[7] =   0x00000000;	//1.(1)
	ICDICFR[14] = 0x55555555;	//1.(2) 
	ICDIPR[58] =  0x00000000;	//1.(3) 00FF 0000 Priority 
	ICDIPR[59] =  0x00000000;	//1.(3) 00FF 0000
	ICDIPTR[58] = 0x01010100;	//1.(4) 0101 0100 //ICDIPTR58.8-15,16-23,24-32 T
	ICDIPTR[59] = 0x00000001;	//1.(4) 0101 0100 //ICDIPTR59.0-7 only TX Target CPU
//	ICDISER[7] =  0x00001E00;	//1.(5)	//ICDISER7.9-12 BE ER RX TX Enable Set
//	ICDISER[7] =  0x00000E00;	//1.(5)	//ICDISER7.9-12 BE ER RX TX Enable Set

	ICDISER[7] =  0x00000600;	//1.(5)	//ICDISER7.9-12 BE ER Enable Set
	
	ICC->PMR = 0x0F;
	ICC->BPR = 0x00;
	ICC->ICR = 0x03;
	
	*ICDDCR = 0x01;

}

putch(volatile struct sc_str *p, int ch) {
	while(!(p->SCFSR & 0x20 ));	// TDFEmpty
	p->SCFTDR = ch;
	p->SCFSR &= ~0x60;	// Clear TEND/TDFE
}

getch(volatile struct sc_str *p ){
	int	ch;
	if(p->SCFSR & 0x91) { p->SCFSR &= ~0x91; }//0x80 ER 0x10 BRK 0x01 DR
	if(p->SCLSR & 0xFF) { p->SCLSR = 0; }

	while(!(p->SCFSR & 0x02));	//  RDF
	ch = p->SCFRDR;
	p->SCFSR &= ~0x02;		// Clear RDF
	return ch;
}

puts(char * str)
{
	while(*str) {
		putch(SC3,*str++);
	}
}

void initializeCPU(){	
	*RMPR = 0x00;	// Address Remap

	setLowVector();		// setHighVector();

//	tfp_printf("SCTLR = %x\r\n", readSCTLR());
//	tfp_printf("Original Vector Base = %x\r\n",readVectorBaseRegister());	

	writeVectorBaseRegister(0x20200000);	// For GDB stub

//	tfp_printf("New Vector Base= %x\r\r\n",readVectorBaseRegister());	
}

/*	On Board LED 	1 bit  P1.18 (L.on)	*/
initializeBoardLED(){
	PMC->P7	&= ~0x0300	;
	PM->P7	&= ~0x0300	;
//	PORT->P7	|=  0x0100	;	// No.0 1:OFF  
//	PORT->P7	&= ~0x0200	;	// No.1 0:ON (Center Side)
//	PORT->P7	&= ~0x0300	;	// No.1 0:ON (Center Side)
	PORT->P7	|=  0x0300	;	// No.0 1:OFF  
}

//reverseLED(){PORT->P7^=0x0300;}
//reverseLED0(){PORT->P7^=0x0100;}
//reverseLED1(){PORT->P7^=0x0200;}

////offLED0(){PORT->P7|=0x0100;}
//offLED1(){PORT->P7|=0x0200;}	//Center Side
//onLED0(){PORT->P7&=~0x0100;}
//onED1(){PORT->P7&=~0x0200;}	//Center Side

char
getDebugChar (void)
{ return  getch(SC3); }

void
putDebugChar (char ch)
{ putch(SC3,ch); }

void
interrupt(void) {// IRQ Handler for ARM CPU	

	//	if(cause == 235) {
	//		putch( getch() );
	//	}

	if(SC3->SCFSR & 0x18) {
		int	prior, cause;
		prior = ICC->HPIR;
		cause = ICC->IAR;	//bit0-9 INT-ID 10-12 CPU ID
		if((cause == 233)|(cause ==234) ){ //BREAK || Frame Error
			//reverseLED0();
			SC3->SCFSR &= ~0x98;	//
			SC3->SCFCR = 00;		//
			//	 0xF000	Parity Error Numbrt	 0x0F00	Framing Error Numbrt
			//	 0x80 ERror	 0x40 TEND	 0x20 TDFEmpty	 0x10 BRK
			//	 0x0f FERror	 0x04 PERror	 0x02 RDFull	 0x01 (Recieve)DReasy
			handleException(0);
		}
		ICC->EOIR = cause;
	}
}

