/************************************************************************/
/*  A Part of ARM Cortex-A9 GNU GDB Stub Software.			*/
/*   				Copyright (C) 2013 Toshio MURAI		*/
/* This program is free software; you can redistribute it and/or modify	*/
/* it under the terms of the GNU General Public License as published by	*/
/* the Free Software Foundation; either version 3 of the License, or	*/
/* (at your option) any later version.					*/
/*									*/
/* This program is distributed in the hope that it will be useful,	*/
/* but WITHOUT ANY WARRANTY; without even the implied warranty of	*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*/
/* GNU General Public License for more details.  			*/
/************************************************************************/

/************************************************************************/
/*	!!!!! Caution!!!!!	This code is terribely Tricky !!!!!	*/
/*	Never change the size of both array and the location.		*/
/*	Never add variables and functions.				*/
/*	Never optimize this code by gcc.	If optimized,		*/ 
/*		the order of the array may changes and it never works.	*/
/*	You can only change the name of exception handling funciton.	*/
/************************************************************************/

#define	NOP	0xe1a00000
#define	JMP	0xe59ff018
const long int instructionTable[]= {		/* Address must be 0x00000000 TOP Address */
	JMP,	//0x00:   e59ff018        ldr     pc, [pc, #24]   ; 20 <reset_vect
	JMP,	//0x04:   e1a00000        nop                     ; (mov r0, r0)
	JMP,	//0x08:   e1a00000        nop                     ; (mov r0, r0)
	JMP,	//0x0c:   e1a00000        nop                     ; (mov r0, r0)
	JMP,	//0x10:   e1a00000        nop                     ; (mov r0, r0)
	NOP,	//0x14:   e1a00000        nop                     ; (mov r0, r0)
	JMP,	//0x18:   e59ff018        ldr     pc, [pc, #24]   ; 38 <irq_vector
	JMP,	//0x1c:   e1a00000        nop                     ; (mov r0, r0)	
};

#define	FNOP	((void(*)(void)) 0xe1a00000)
#define	FJMP	((void(*)(void)) 0xe59ff018)
#define	NONE	((void(*)(void)) 0x00000000)

extern	void	_start(void);
extern	void	_interrupt(void);
extern	void	_undefinedInstruction(void);

extern	void	_softwareInterrupt(void);
extern	void	_prefetchAbort(void);
extern	void	_dataAbort(void);
extern	void	_interrupt(void);
extern	void	_firstInterrupt(void);
void (*const vectorTable[])(void) = {	/* Address must be + 0x00000020*/
	_start,			// 0x20	Reset
	_undefinedInstruction,	// 0x24 Undefined Instruction
	_softwareInterrupt,	// 0x28 Software Interrupt 
	_prefetchAbort,		// 0x2C Prefetch Abort
	_dataAbort,		// 0x30 Data Abort 
	NONE,			// 0x34 Reserved
	_interrupt,		// 0x38 IRQ
	_firstInterrupt,	// 0x3C FIQ
};

