/****************************************************************/
/* GNU CC Common Control Software / (C) Toshio MURAI 2011-2013	*/
/*  This is Free Software;   You can redistribute this software	*/
/*  and/or modify it under the terms of the GNU General Publicr	*/
/*  License version 3, or (at your option) any later version.	*/
/****************************************************************/
	.text
#
#	Power	On Reset Start up Routine
#
	.globl	start
start:

	MOV	R1,	#0xD2	/*#(CPSR_MD_IRQ=0x12|CPSR_IRQ=0x80|CPSR_FIQ=0x40) ~THUMB 0x20	*/
	MSR	CPSR_cxsf,	R1	/* C:0-7 X:8-15 S:16-23 F:24-31		*/
	LDR	SP,	= _interruptStack	/* R13 Interrupt Task Context stack */
	MOV	R1,	#0xD3	/*#(CPSR_MD_IRQ=0x12|CPSR_IRQ=0x80|CPSR_FIQ=0x40) ~THUMB 0x20	*/
	MSR	CPSR_cxsf,	R1	/* C:0-7 X:8-15 S:16-23 F:24-31		*/
	LDR	SP,	= _systemStack	/* R13 Interrupt Task Context stack */

	BL	initializeMemory
	BL	main
exit:
	b	exit


#
#	Interrupt	disable
#
.global	disableInterrupt
disableInterrupt:	/*	 IRQ Disable	FIQ 0x40*/
	MRS	R0,	CPSR
	ORR	R0,	R0	,#0x080	/*#CPSR_IRQ*/
	MSR	CPSR_cxsf,	R0
	MOV	PC,	LR		 /*  return */
#
#	Interrupt	enable
#
.global	enableInterrupt
enableInterrupt:	/*	 IEQ Enable FIQ ~0x40*/

	MRS	R0,	CPSR
	AND	R0,	R0	,#~0x80	/*#~CPSR_IRQ*/
	MSR	CPSR_cxsf,	r0
	MOV	PC,	LR		 /*  return */


##########################################################
.global	undefInst
undefInst:
	.long	0xE7FFDEFE
	.long	0xE7FFDEFE

##########################################################
#MRC	p15, 0, <Rd>, c12, c0, 0 ; Read VBAR Register
#MCR	p15, 0, <Rd>, c12, c0, 0 ; Write VBAR Register

.global	readVectorBaseRegister
readVectorBaseRegister:
	MRC	P15,	0, R0, C12, C0, 0 
	MOV	PC,	LR		 /*  return */

.global	writeVectorBaseRegister
writeVectorBaseRegister:
#	MRC	p15,	0, r0, c12, c0, 0 
#	LDR	r0,#0x20100000
	MCR	P15,	0, R0, C12, C0, 0 
	MOV	PC,	LR		 /*  return */

##########################################################
.global	setHighVector
setHighVector:
	MRC	P15,	0,R0, C1, C0, 0
	MOV	R1,#0x00002000
	ORR	R0,R1
	MCR	P15,	0,R0, C1, C0, 0
	MOV	PC,	LR		 /*  return */
	
.global	setLowVector
setLowVector:
	MRC	P15,	0,R0, C1, C0, 0
	MOV	R1,#0xFFFFDFFF
	AND	R0,R1
	MCR	P15,	0,R0, C1, C0, 0
	MOV	PC,	LR		 /*  return */

.global	readSCTLR
readSCTLR:
	MRC	P15,	0,R0, C1, C0, 0
	MOV	PC,	LR		 /*  return */

#MRC	P15, 0,<Rd>, C1, C0, 0; Read SCTLR
#MCR	P15, 0,<Rd>, C1, C0, 0; Write SCTLR
#	Vbit	13th bit
