/************************************************************************/
/*	 CEV-RZ/A1l  GNU CC Control Software / (C) Toshio MURAI  2013	*/
/*      This is Free Software;   You can redistribute this software     */
/*      and/or modify it under the terms of the GNU General Public      */
/*      License version 3, or (at your option) any later version.       */
/************************************************************************/

#define	RMPR		((volatile unsigned int *)0xFCFE1A00) //	Remap register

// Interrupt Set up 1st
#define	ICDISR	((volatile unsigned int*)0xE8201080)	// (1) Security
#define	ICDICFR	((volatile unsigned int*)0xE8201C00)	// (2) Configuration
#define	ICDIPR	((volatile unsigned int*)0xE8201400)	// (3) Priority
#define	ICDIPTR	((volatile unsigned int*)0xE8201800)	// (4) Target CPU
#define ICDISER	((volatile unsigned int*)0xE8201100)	// (5) Interrupt Enable
#define	ICDICER ((volatile unsigned int*)0xE8201180)	//	//Interrupt Enable Clear Register
#define	ICDISPR	((volatile unsigned int*)0xE8201200)	//	//Suspend set 
#define	ICDICPR	((volatile unsigned int*)0xE8201280)	//	//Suspend Clear  
#define	ICDABR	((volatile unsigned int*)0xE8201300)	//	//ACtive bit register 

// Interrupt Set up 2nd
struct cpuif_str {
	unsigned int	ICR;	//2nd.(3)	=0x00000003 CPU interface Control
	unsigned int	PMR;	//2nd.(1)	CPU  Priority Mask < 0xFF
	unsigned int	BPR;	//2nd.(2)	binary point ?= 0x00
	unsigned int	IAR;	//ICCIAR	((volatile unsigned int*)0xE820200C)
	unsigned int	EOIR;	//ICCEOIR	((volatile unsigned int*)0xE8202010)
	unsigned int	RPR;
	unsigned int	HPIR;	//ICCHPIR ((volatile unsigned int*)0xE8202018)
	unsigned int	ABPR;
	unsigned int	IIDR;
};
#define ICC	((volatile struct cpuif_str*) 0xE8202000)	// Distribute Control =1

// Interrupt Set up 3rd
#define	ICDDCR	 ((volatile unsigned int*)0xE8201000)	// Distribute Control =1
// Interrupt Set up 4th CPSR (I/F)

////////// UART3
// IO structure
struct sc_str{
	unsigned short	SCSMR;	short NSCSMR;
	unsigned char	SCBRR;	char ZSCBRR;short NSCBRR;
	unsigned short	SCSCR;	short NSCSCR;
	unsigned char	SCFTDR;	char ZSCFTDR;short NSCFTDR;
	unsigned short	SCFSR;	short NSCFSR;
	unsigned char	SCFRDR;	char ZSCFRDR;short NSCFRDR;
	unsigned short	SCFCR;	short NSCFCR;
	unsigned short	SCFDR;	short NSCFDR;
	unsigned short	SCSPTR;	short NSCSPTR;
	unsigned short	SCLSR;	short NSCLSR;
	unsigned short	SCEMR;	short NSCEMR;
};
#define	SC0	((volatile struct sc_str *)0xE8007000)
#define	SC1	((volatile struct sc_str *)0xE8007800)
#define	SC2	((volatile struct sc_str *)0xE8008000)
#define	SC3	((volatile struct sc_str *)0xE8008800)
#define	SCPORT	SC3	

///////// GPIO        
struct gpio_str{
	unsigned short	P0;	short NP0;
	unsigned short	P1;	short NP1;
	unsigned short	P2;	short NP2;
	unsigned short	P3;	short NP3;
	unsigned short	P4;	short NP4;
	unsigned short	P5;	short NP5;
	unsigned short	P6;	short NP6;
	unsigned short	P7;	short NP7;
};

struct gpiol_str{
	unsigned int	P0;
	unsigned int	P1;
	unsigned int	P2;
	unsigned int	P3;
	unsigned int	P4;
	unsigned int	P5;
	unsigned int	P6;
	unsigned int	P7;
};

#define	PORT	((volatile struct gpio_str *)0xFCFE3000)
#define	PSR	((volatile struct gpiol_str *)0xFCFE3100)
#define	PPR	((volatile struct gpio_str *)0xFCFE3200)
#define	PM	((volatile struct gpio_str *)0xFCFE3300)
#define	PMC	((volatile struct gpio_str *)0xFCFE3400)
#define	PFC	((volatile struct gpio_str *)0xFCFE3500)
#define	PFCE	((volatile struct gpio_str *)0xFCFE3600)
#define	PNOT	((volatile struct gpio_str *)0xFCFE3700)
#define	PMSR	((volatile struct gpiol_str *)0xFCFE3800)
#define	PMCSR	((volatile struct gpiol_str *)0xFCFE3900)
#define	PFCAE	((volatile struct gpio_str *)0xFCFE3A00)
#define	PIBC	((volatile struct gpio_str *)0xFCFE4000)
#define	PBDC	((volatile struct gpio_str *)0xFCFE4100)
#define	PIPC	((volatile struct gpio_str *)0xFCFE4200)

/////////// OSTimer
// OS Timer ID 134 OSTM0TINT
struct ostm_str {
	unsigned int	CMP;//compare register 
	unsigned int	CNT;//counter register 
	unsigned int	NON0;
	unsigned int	NON1;
	unsigned char	TE; char CTE	;short NTE;//count enable status R 
	unsigned char	TS; char CTS	;short NTS;//count start trigger   
	unsigned char	TT; char CTT	;short NTT;//count stop trigger    
	unsigned int	NONE;
	unsigned char	CTL; char CCTL	;short NCTL;//control register 
};
#define	OSTM0	((volatile struct ostm_str*)0xFCFEC000)


