/************************************************************************/
/* 	CEV-RZ/A1l  GNU CC Control Software / (C) Toshio MURAI  2013	*/
/*      This is Free Software;   You can redistribute this software     */
/*      and/or modify it under the terms of the GNU General Public      */
/*      License version 3, or (at your option) any later version.       */
/************************************************************************/
#include 	"io.h"

void	initializeHardware(void) ;
int	getch(volatile struct sc_str *);
void	putch(volatile struct sc_str *,int);

//*************************************************************************/
int main(void){	
	initializeHardware();	

	putstr("Hello A9 Board Test Program.\n");

	while(1) {
		int ch; 
		ch=getch(SCPORT);
		putch(SCPORT,ch);
		reverseLED0(); reverseLED1();
		if(ch=='Z') {
			stopTimer();
			break;
		}
	}
	offLED0(); offLED1();
}

//*************************************************************************/
void	initializeCPU(void);
void	initializeBoardLED(void);
void	initializeIRQ(void);
void	initializeTimer(void);
void	initializeUART(void);

void initializeHardware() {
	disableInterrupt();
	
	initializeCPU();	//	set vector

	initializeBoardLED();	//	P7_8, P7_9 ( RED LED )

	initializeTimer();	// 	set OS Timer

	initializeUART();	//	initialize RS232C serial port (115200bps)

	enableInterrupt();
}

//***********************************************************************/
//*	GNU Linker .text/.bss Initialize routine before main function.	*/
//***********************************************************************/
extern char etext[], sdata[], edata[], sbss[] , ebss[];

void initializeMemory()
{
	char *src, *dst;
	
	for( src = etext, dst = sdata ; dst< edata ; ) 
		*dst++ = *src++;
		
	for( dst=sbss                 ; dst< ebss  ; ) 
		*dst++ =0;
}

