/************************************************************************/
/* CEV-RZ/A1l  GNU CC Control Software / (C) Toshio MURAI  2013		*/
/*      This is Free Software;   You can redistribute this software     */
/*      and/or modify it under the terms of the GNU General Public      */
/*      License version 3, or (at your option) any later version.       */
/************************************************************************/
/*	Never change the size of both array and the location.		*/
/*	Tricky and never optimaize this code using -O.It will not work.*/
/************************************************************************/

#define	NOP	0xe1a00000
#define	JMP	0xe59ff018

const long int instructionTable[]= {		/* GO Address 0x00000000 TOP Address */
	JMP,	//0x00:   e59ff018        ldr     pc, [pc, #24]   ; 20 <reset_vect
	JMP,	//0x04:
	JMP,	//0x08:
	JMP,	//0x0c:
	JMP,	//0x10:
	JMP,	//0x14:
	JMP,	//0x18:
	JMP,	//0x1c: 
};

extern	void	start(void);
extern	void	undefinedInstruction(void);
extern	void	softwareInterrupt(void);
extern	void	prefetchAbort(void);
extern	void	dataAbort(void);
extern	void	interrupt(void);
extern	void	finterrupt(void);

void (*const vectorTable[])(void) = {	/* GO Address 0x00000020*/
	start,			// 0x20	Reset
	undefinedInstruction,	// 0x24 Undefined Instruction
	softwareInterrupt,	// 0x28 Software Interrupt 
	prefetchAbort,		// 0x2C Prefetch Abort
	dataAbort,		// 0x30 Data Abort 
	0x00,			// 0x34 Reserved
	interrupt,		// 0x38 IRQ
	finterrupt,		// 0x3C FIQ
};

