/************************************************************************/
/* 	CEV-RZ/A1l  GNU CC Control Software / (C) Toshio MURAI  2013	*/
/*      This is Free Software;   You can redistribute this software     */
/*      and/or modify it under the terms of the GNU General Public      */
/*      License version 3, or (at your option) any later version.       */
/************************************************************************/

void	initializeHardware(void) ;

//*************************************************************************/
// ARM branch instruction single step execution test program. (for gdbstub)
//*************************************************************************/

extern void branch1();
extern void branch2();
extern void branch3();
extern void branch4();
extern void branch5();

void (*const ftable[])(void) = {
	branch1,
	branch2,
	branch3,
	branch4,
	branch5,
};

int main(void){	
	int	i;

	branch0();

	for(i=0; i < sizeof(ftable)/sizeof(void(*)()) ;i++) {
		ftable[i]();
	}

	i ='g';
	switch (i) {
	case 'H': case '!':
		branch0();
		break;
	case '?':
		branch1();
		break;
	case 'g':
		branch2();
		break;
	case 'G':	
		break;
	case 'P':
		break;
	case 'm':
		branch3();
		break;
	case 'M':
		branch0();
		break;
	case 'S': case 's':
		 branch5();
	case 'C': case 'c':
		 return;
	case 'Z': case 'z': case 'k': case 'R':	case 'r':
	default:
		break;
	}		/* switch */


	i = *((int*)0x80000000);	// Bus Error Stop
	((void (*)(void) )0x80000000)();	// Segmentation Error Stop
}
branch0()
{
	return 0;
}

//*************************************************************************/


//***********************************************************************/
//*	GNU Linker .text/.bss Initialize routine before main function.	*/
//***********************************************************************/
extern char etext[], sdata[], edata[], sbss[] , ebss[];

void initializeMemory()
{
	char *src, *dst;
	
	for( src = etext, dst = sdata ; dst< edata ; ) 
		*dst++ = *src++;
		
	for( dst=sbss                 ; dst< ebss  ; ) 
		*dst++ =0;
}

